local mod = ...



-- Building Asset Processor ------------------------------------------------------------------
mod:registerAssetProcessor("models/Cathedral3.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- -- Building Part Type ------------------------------------------------------------------
-- mod:registerEnumValue("BUILDING_PART_TYPE", "EXTENSION")
-- mod:registerEnumValue("ATTACH_NODE_TYPE", "EXTENSION")



-- Materials -------------------------------------------------------------------------------------
mod:registerAssetId("models/Cathedral3.fbx/Materials/Material.Blue1", "MATERIAL_ORTHODOX_CHURCH_BLUE1")
mod:registerAssetId("models/Cathedral3.fbx/Materials/Material.Blue2", "MATERIAL_ORTHODOX_CHURCH_BLUE2")
mod:registerAssetId("models/Cathedral3.fbx/Materials/Material.Pattern", "MATERIAL_ORTHODOX_CHURCH_PATTERN")
mod:registerAssetId("models/Cathedral3.fbx/Materials/Material.Gold", "MATERIAL_ORTHODOX_CHURCH_GOLD")
mod:registerAssetId("models/Cathedral3.fbx/Materials/Material.RoofTerracotta", "MATERIAL_ORTHODOX_CHURCH_ROOFTERRACOTTA")
mod:registerAssetId("models/Cathedral3.fbx/Materials/Material.RoofBlue", "MATERIAL_ORTHODOX_CHURCH_ROOFBLUE")
mod:registerAssetId("models/Cathedral3.fbx/Materials/Material.RoofRed", "MATERIAL_ORTHODOX_CHURCH_ROOFRED")



-- Grounding
mod:registerPrefabComponent("models/Cathedral3.fbx/Prefab/Door1Part", {DataType = "COMP_GROUNDED"})

for i=1, 4, 1 do
	mod:registerPrefabComponent("models/Cathedral3.fbx/Prefab/Hall1RootPart/Attach_Door_Hall1." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 8, 1 do
	mod:registerPrefabComponent("models/Cathedral3.fbx/Prefab/Tower1RootPart/Attach_Door_Tower1." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/Cathedral3.fbx/Prefab/Tower2RootPart/Attach_Door_Tower2." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end

for i=1, 16, 1 do
	mod:registerPrefabComponent("models/Cathedral3.fbx/Prefab/Dome1RootPart/Attach_Door_Dome1." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
	mod:registerPrefabComponent("models/Cathedral3.fbx/Prefab/Dome2RootPart/Attach_Door_Dome2." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
end



-- Scaling assets -------------------------------------------------------------------------------------
mod:registerAssetId("models/Cathedral3.fbx/Prefab/RootPart", "PREFAB_ORTHODOX_CHURCH_ROOT")

function registerScalingA(_modelRoot, _modelTiling, _modelEnd, _modelConstr, _partName, _partType, _buildingZone, _costBuild, _costUpkeep, _costEnd, _costTiling, _capacity)

	mod:registerAssetId("models/Cathedral3.fbx/Prefab/" .. _modelRoot, "PREFAB_BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_ROOT")
	mod:registerAssetId("models/Cathedral3.fbx/Prefab/" .. _modelTiling, "PREFAB_BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_TILING")
	mod:registerAssetId("models/Cathedral3.fbx/Prefab/" .. _modelEnd, "PREFAB_BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_END")

    -- Basement
    mod:register({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_BASEMENT",
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_TILING"
        },
        ConstructionVisual = "PREFAB_BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_TILING",
        Cost = _costTiling,
    })

    -- Tiling
    mod:register({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_TILING",
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_TILING"
        },
        -- ConstructionVisual = "PREFAB_BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_TILING",
        Cost = _costTiling,
    })

    -- End
    mod:register({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_END",
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_END"
        },
        Cost = _costEnd,
    })

    -- Construction model
    if (_modelConstr) then
        mod:log("construction model found for " .. _partName)
        mod:registerAssetId("models/Cathedral3.fbx/Prefab/" .. _modelConstr, "PREFAB_BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_END_CONSTR")
        mod:override({
            Id = "BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_END",
            ConstructionVisual = "PREFAB_BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_END_CONSTR",
        })
    end
    

    -- Final
    mod:register({
        DataType = "BUILDING_PART",
		Id = "BUILDING_PART_ORTHODOX_CHURCH_" .. _partName,
		Name = "BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_NAME", 
        -- IsMovableWhenBuilt = true,
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_SCALER",
            CoreObjectPrefab = "PREFAB_BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_ROOT",
            EndPart = "BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_END",
            FillerList = {
                "BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_TILING",
            },
            BasementFillerList = {
                "BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_BASEMENT",
            },
            MinimumScale = 0,
            IsVertical = true
        },
        BuildingZone = _buildingZone,
        -- Category = "CORE",
        Cost = {
            BuildRightTaxes = {	{ Resource = "GOLD", Quantity = _costBuild } },
            UpkeepCost = { { Resource = "GOLD", Quantity = _costUpkeep } },
            -- RessourcesNeeded = {
            --     { Resource = "WOOD", Quantity = 80 },
            -- }
        }
    })

    -- Capacity
    if (_capacity) then
        if (_capacity > 0) then
            mod:override({
                Id = "BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_END",
                Capacity = _capacity,
                AssetBuildingFunction = "BUILDING_FUNCTION_PUBLIC_LOUNGE_ROOM",
            })
        end
    end

end

_BuildingZoneTowerSmall = { ZoneEntryList = { { Polygon = polygon.createCircle( 1.7, { 0, 0 }, 16 ), Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } } } }
_BuildingZoneTowerLarge = { ZoneEntryList = { { Polygon = polygon.createCircle( 2.7, { 0, 0 }, 16 ), Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } } } }
_BuildingZoneDomeSmall = { ZoneEntryList = { { Polygon = polygon.createCircle( 6.0, { 0, 0 }, 16 ), Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } } } }
_BuildingZoneDomeLarge = { ZoneEntryList = { { Polygon = polygon.createCircle( 9.0, { 0, 0 }, 16 ), Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } } } }
_BuildingZoneHallSmall = { ZoneEntryList = { { Polygon = polygon.createRectangle( {6, 6}, {0, 0} ), Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } } } }
_BuildingZoneHallLarge = { ZoneEntryList = { { Polygon = polygon.createRectangle( {9, 9}, {0, 0} ), Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } } } }

_CostEmpty = {  }
_CostDomeSmallEnd = { RessourcesNeeded = { { Resource = "WOOD", Quantity = 10 }, { Resource = "STONE", Quantity = 10 }, { Resource = "POLISHED_STONE", Quantity = 25 }, } }
_costDomeSmallTiling = { RessourcesNeeded = { { Resource = "POLISHED_STONE", Quantity = 10 }, } }
_CostDomeLargeEnd = { RessourcesNeeded = { { Resource = "WOOD", Quantity = 20 }, { Resource = "STONE", Quantity = 20 }, { Resource = "POLISHED_STONE", Quantity = 50 }, } }
_costDomeLargeTiling = { RessourcesNeeded = { { Resource = "POLISHED_STONE", Quantity = 15 }, } }
_CostHallEnd = { RessourcesNeeded = { { Resource = "STONE", Quantity = 5 }, { Resource = "POLISHED_STONE", Quantity = 15 }, } }
_CostHallTiling = { RessourcesNeeded = { { Resource = "POLISHED_STONE", Quantity = 5 }, } }
_CostTowerSmallEnd = { RessourcesNeeded = { { Resource = "WOOD", Quantity = 10 }, { Resource = "STONE", Quantity = 10 }, { Resource = "POLISHED_STONE", Quantity = 20 }, } }
_CostTowerSmallTiling = { RessourcesNeeded = { { Resource = "POLISHED_STONE", Quantity = 5 }, } }
_CostTowerLargeEnd = { RessourcesNeeded = { { Resource = "WOOD", Quantity = 20 }, { Resource = "STONE", Quantity = 20 }, { Resource = "POLISHED_STONE", Quantity = 40 }, } }
_CostTowerLargeTiling = { RessourcesNeeded = { { Resource = "POLISHED_STONE", Quantity = 8 }, } }
_CostExtensionSmallEnd = { RessourcesNeeded = { { Resource = "STONE", Quantity = 5 }, { Resource = "POLISHED_STONE", Quantity = 10 }, } }
_CostExtensionSmallTiling = { RessourcesNeeded = { { Resource = "POLISHED_STONE", Quantity = 5 }, } }
_CostExtensionLargeEnd = { RessourcesNeeded = { { Resource = "STONE", Quantity = 10 }, { Resource = "POLISHED_STONE", Quantity = 20 }, } }
_CostExtensionLargeTiling = { RessourcesNeeded = { { Resource = "POLISHED_STONE", Quantity = 10 }, } }

-- Facing down with x pointing up in Blender: y increases going left, x increases going down
local poly1 = { -- y, x
	{ -2.3, -2.3 },
    { -2.3, 0.5},
    { -1.9, 1.6},
    { -0, 2.6 },
    { 1.9, 1.6 },
    { 2.3, 0.5 },
    { 2.3, -2.3},
}

local poly2 = { -- y, x
	{ -3.6, -3.6 },
    { -3.6, 1.8},
    { -3.2, 2.9},
    { 0, 3.9 },
    { 3.2, 2.9 },
    { 3.6, 1.8 },
    { 3.6, -3.6},
}

_BuildingZoneExtensionSmall = { ZoneEntryList = { { Polygon = poly1, Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } } } }
_BuildingZoneExtensionLarge = { ZoneEntryList = { { Polygon = poly2, Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } } } }


-- function registerScalingA(_modelRoot, _modelTiling, _modelEnd, _modelConstr, _partName, _partType, _buildingZone, _costBuild, _costUpkeep, _costEnd, _costTiling, _capacity)
registerScalingA("Tower1RootPart", "Tower1TilingPart", "Tower1EndPart", "Tower1EndPart.Constr", "TOWER1", "", _BuildingZoneTowerSmall, 5, 5, _CostTowerSmallEnd, _CostTowerSmallTiling, 5)
registerScalingA("Tower2RootPart", "Tower2TilingPart", "Tower2EndPart", "Tower2EndPart.Constr", "TOWER2", "", _BuildingZoneTowerLarge, 10, 10, _CostTowerLargeEnd, _CostTowerLargeTiling, 10)
registerScalingA("Dome1RootPart", "Dome1TilingPart", "Dome1EndPart", "Dome1EndPart.Constr", "DOME1", "", _BuildingZoneDomeSmall, 20, 20, _CostDomeSmallEnd, _costDomeSmallTiling, 20)
registerScalingA("Dome2RootPart", "Dome2TilingPart", "Dome2EndPart", "Dome2EndPart.Constr", "DOME2", "", _BuildingZoneDomeLarge, 40, 40, _CostDomeLargeEnd, _costDomeLargeTiling, 40)
registerScalingA("Hall1RootPart", "Hall1TilingPart", "Hall1EndPart", "Hall1EndPart.Constr", "HALL1", "", _BuildingZoneHallSmall, 10, 10, _CostHallEnd, _CostHallTiling, 10)
registerScalingA("Extension1RootPart", "Extension1TilingPart", "Extension1EndPart", "Extension1EndPart.Constr", "EXTENSION1", "", _BuildingZoneExtensionSmall, 5, 5, _CostExtensionSmallEnd, _CostExtensionSmallTiling, 5)
registerScalingA("Extension2RootPart", "Extension2TilingPart", "Extension2EndPart", "Extension2EndPart.Constr", "EXTENSION2", "", _BuildingZoneExtensionLarge, 10, 10, _CostExtensionLargeEnd, _CostExtensionLargeTiling, 10)



-- Simple assets -------------------------------------------------------------------------------------
function registerSimpleA(_modelName, _partName, _partType, _buildingZone, _costPart)

	mod:registerAssetId("models/Cathedral3.fbx/Prefab/" .. _modelName, "PREFAB_BUILDING_PART_ORTHODOX_CHURCH_" .. _partName)
	
	mod:register({
		DataType = "BUILDING_PART",
		Id = "BUILDING_PART_ORTHODOX_CHURCH_" .. _partName,
		Name = "BUILDING_PART_ORTHODOX_CHURCH_" .. _partName .. "_NAME", 
        BuildingZone = _buildingZone,
        IsMovableWhenBuilt = true,
		ConstructorData = {
			DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
			CoreObjectPrefab = "PREFAB_BUILDING_PART_ORTHODOX_CHURCH_" .. _partName
		},
        Cost = _costPart
	})

    -- Building Part Type
    if (_partType ~= "") then

        mod:registerPrefabComponent("models/Cathedral3.fbx/Prefab/" .. _modelName, {
            DataType = "COMP_BUILDING_PART",
            BuildingPartType = _partType
        })

    end

end

_BuildingZoneDoorSmall = { ZoneEntryList = { { Polygon = polygon.createRectangle( {4.0, 3.5}, {1.8, 0} ), Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } } } }
_BuildingZoneEmpty = { ZoneEntryList = {  } }

_costDoor = { UpkeepCost = { { Resource = "GOLD", Quantity = 1 } }, RessourcesNeeded = { { Resource = "WOOD", Quantity = 4 }, { Resource = "POLISHED_STONE", Quantity = 8 }, } }
_costRoof = { UpkeepCost = { { Resource = "GOLD", Quantity = 2 } }, RessourcesNeeded = { { Resource = "WOOD", Quantity = 4 }, { Resource = "POLISHED_STONE", Quantity = 8 }, } }
_costCross = { RessourcesNeeded = { { Resource = "WOOD", Quantity = 1 }, } }

-- function registerSimpleA(_modelName, _partName, _partType, _buildingZone, _costPart)
registerSimpleA("Door1Part", "DOOR1", "DOOR", _BuildingZoneDoorSmall, _costDoor)
registerSimpleA("Roof1Part", "ROOF1", "", _BuildingZoneEmpty, _costRoof)
registerSimpleA("Roof2Part", "ROOF2", "", _BuildingZoneEmpty, _costRoof)
registerSimpleA("Cross1Part", "CROSS1", "MINOR", _BuildingZoneEmpty, _costCross)
registerSimpleA("Cross2Part", "CROSS2", "MINOR", _BuildingZoneEmpty, _costCross)



-- -- Attach nodes
-- for i = 1, 8, 1 do
--     mod:registerPrefabComponent("models/FrontierChurch1.fbx/Prefab/Core1BasementPart/Attach_Extension." .. string.sub("000" .. i, -3), { DataType = "COMP_BUILDING_ATTACH_NODE", AttachNodeTypeList = { "EXTENSION" }, AllowedAngles = {-45, 45} })
--     -- mod:log("models/FrontierChurch1.fbx/Prefab/Core1BasementPart/Attach_Extension." .. string.sub("000" .. i, -3))
-- end

-- for i = 9, 12, 1 do
--     mod:registerPrefabComponent("models/FrontierChurch1.fbx/Prefab/Extension1BasementPart/Attach_Extension." .. string.sub("000" .. i, -3), { DataType = "COMP_BUILDING_ATTACH_NODE", AttachNodeTypeList = { "EXTENSION" }, AllowedAngles = {-45, 45} })
--     -- mod:log("models/FrontierChurch1.fbx/Prefab/Extension1BasementPart/Attach_Extension." .. string.sub("000" .. i, -3))
-- end



-- -- Grounding
-- mod:registerPrefabComponent("models/FrontierChurch1.fbx/Prefab/Door1Part", {DataType = "COMP_GROUNDED"})

-- -- for i=1, 4, 1 do
-- -- 	mod:registerPrefabComponent("models/FrontierChurch1.fbx/Prefab/Core1Construction/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
-- -- end

-- -- for i=1, 8, 1 do
-- -- 	mod:registerPrefabComponent("models/FrontierChurch1.fbx/Prefab/Extension1Construction/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
-- -- end

-- -- for i=5, 8, 1 do
-- -- 	mod:registerPrefabComponent("models/FrontierChurch1.fbx/Prefab/Extension1Construction/Step_0." .. string.sub("000" .. i, -3), {DataType = "COMP_GROUNDED"})
-- -- end



-- -- Collider Platform (climbable mesh)  -------------------------------------------------------------------------------------
-- -- mod:configurePrefabFlagList("models/FrontierKeep1.fbx/Prefab/KeepPart", { "PLATFORM" })



-- Building: Orthodox Church -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_ORTHODOX_CHURCH",
	Name = "BUILDING_ORTHODOX_CHURCH_NAME",
	Description = "BUILDING_ORTHODOX_CHURCH_DESC",
	BuildingType = "MONUMENT",
    AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
    AssetBuildingFunction = "BUILDING_FUNCTION_CHURCH",
	BuildingPartSetList = {
		{
			Name = "BUILDING_SET_ORTHODOX_CHURCH1_NAME",
			BuildingPartList = { 
				"BUILDING_PART_ORTHODOX_CHURCH_DOME1",
				"BUILDING_PART_ORTHODOX_CHURCH_EXTENSION1",
				"BUILDING_PART_ORTHODOX_CHURCH_HALL1",
				"BUILDING_PART_ORTHODOX_CHURCH_ROOF1",
				"BUILDING_PART_ORTHODOX_CHURCH_ROOF2",
				"BUILDING_PART_ORTHODOX_CHURCH_DOOR1",
				"BUILDING_PART_ORTHODOX_CHURCH_CROSS1",
				"BUILDING_PART_ORTHODOX_CHURCH_TOWER1",
			}
		},
		{
			Name = "BUILDING_SET_ORTHODOX_CHURCH2_NAME",
			BuildingPartList = { 
				"BUILDING_PART_ORTHODOX_CHURCH_DOME2",
				"BUILDING_PART_ORTHODOX_CHURCH_EXTENSION2",
				"BUILDING_PART_ORTHODOX_CHURCH_CROSS2",
				"BUILDING_PART_ORTHODOX_CHURCH_TOWER2",
			}
		},
    },
	-- RequiredPartList = {
	-- 	{ Category = "CORE", Min = 1, Max = 1 },
	-- 	{ Category = "DOOR", Min = 1, Max = 1 },
	-- },
	VillagerRequired = { Status = "COMMONER", Quantity = 20 },
	IsEditable = true,
	MaterialSetList = {
		{
			SetName = "MATERIAL_SET_ORTHODOX_CHURCH1_NAME",
			MaterialList = {
				"MATERIAL_ORTHODOX_CHURCH_BLUE1",
				"MATERIAL_ORTHODOX_CHURCH_BLUE2",
				"MATERIAL_ORTHODOX_CHURCH_ROOFBLUE",
			}
		},
		{
			SetName = "MATERIAL_SET_ORTHODOX_CHURCH2_NAME",
			MaterialList = {
				"MATERIAL_ORTHODOX_CHURCH_PATTERN",
				"MATERIAL_ORTHODOX_CHURCH_PATTERN",
				"MATERIAL_ORTHODOX_CHURCH_ROOFTERRACOTTA",
			}
		},
		{
			SetName = "MATERIAL_SET_ORTHODOX_CHURCH3_NAME",
			MaterialList = {
				"MATERIAL_ORTHODOX_CHURCH_GOLD",
				"MATERIAL_ORTHODOX_CHURCH_GOLD",
				"MATERIAL_ORTHODOX_CHURCH_ROOFRED",
			}
		},
		{
			SetName = "MATERIAL_SET_ORTHODOX_CHURCH4_NAME",
			MaterialList = {
				"MATERIAL_ORTHODOX_CHURCH_BLUE1",
				"MATERIAL_ORTHODOX_CHURCH_GOLD",
				"MATERIAL_ORTHODOX_CHURCH_ROOFBLUE",
			}
		},
		{
			SetName = "MATERIAL_SET_ORTHODOX_CHURCH5_NAME",
			MaterialList = {
				"MATERIAL_ORTHODOX_CHURCH_BLUE1",
				"MATERIAL_ORTHODOX_CHURCH_PATTERN",
				"MATERIAL_ORTHODOX_CHURCH_ROOFTERRACOTTA",
			}
		},
	}
})
